// FrogandScorpion.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>

#include <allegro5/allegro.h>
#include <allegro5/allegro_image.h>
#include <allegro5/keyboard.h>
#include <allegro5/allegro_primitives.h>
#include "data.h"

bool gameRunning = true;

void ConvertImageToArray(const char* filepath) {

    // This function is used to convert images to c array so they can be compiled as part of the executable. It is not used during the game.

    ALLEGRO_BITMAP* bitmap = al_load_bitmap(filepath);
    int w = al_get_bitmap_width(bitmap);
    int h = al_get_bitmap_height(bitmap);

    //uint8_t* arr = new uint8_t[w * h * 3 + 2];

    std::cout << "uint8_t arr[] = {";
    std::cout << w;
    std::cout << ",";
    std::cout << h;
    std::cout << ",";


    for (int y = 0; y < h; y++) {
        for (int x = 0; x < w; x++) {

            ALLEGRO_COLOR c = al_get_pixel(bitmap, x, y);
            std::cout << (int)(c.r * 255);
            std::cout << ", ";
            std::cout << (int)(c.g * 255);
            std::cout << ", ";
            std::cout << (int)(c.b * 255);
            if (x != w - 1 || y != h - 1)
                std::cout << ", ";

            //arr[w * x + y] = (int)(c.r * 255);
            //arr[w * x + y + 1] = (int)(c.g * 255);
            //arr[w * x + y + 2] = (int)(c.b * 255);
        }
    }

    std::cout << "};";

    al_destroy_bitmap(bitmap);

}
ALLEGRO_BITMAP* LoadImageFromArray(uint8_t* arr) {

    int w = arr[0];
    int h = arr[1];

    int arrMax = w * h * 3;
    ALLEGRO_BITMAP* oldb = al_get_target_bitmap();
    ALLEGRO_BITMAP* bitmap = al_create_bitmap(w, h);
    al_set_target_bitmap(bitmap);

    int y = -1;
    for (int i = 2; i < arrMax; i += 3) {


        if (((i - 2) / 3) % w == 0)
            y++;


        ALLEGRO_COLOR c = al_map_rgb(arr[i], arr[i + 1], arr[i + 2]);

        al_draw_pixel(((i - 2) / 3) % w, y, c);

    }


    al_set_target_bitmap(oldb);
    return bitmap;

}

#define DISPLAY_WIDTH 640
#define DISPLAY_HEIGHT 480
#define FRAME_INTERVAL 1.0/60

#define GAME_STATE_MENU 0
#define GAME_STATE_CUTSCENE_1 1

#define PI 3.14

int gamestate = 0;

ALLEGRO_BITMAP* mainFont = nullptr;
ALLEGRO_BITMAP* b_menuSplash = nullptr;
ALLEGRO_BITMAP* b_cutscene_frog = nullptr;
ALLEGRO_BITMAP* b_cutscene_parent_frogs = nullptr;
ALLEGRO_BITMAP* b_frog_town_job = nullptr;
ALLEGRO_BITMAP* b_bird_town_job = nullptr;
ALLEGRO_BITMAP* b_bird_town_job_scared = nullptr;

ALLEGRO_BITMAP* b_river_background = nullptr;
ALLEGRO_BITMAP* b_town_background = nullptr;
ALLEGRO_BITMAP* b_scorpion_town_background = nullptr;

ALLEGRO_BITMAP* d_father = nullptr;
ALLEGRO_BITMAP* d_mother = nullptr;
ALLEGRO_BITMAP* d_goodbye = nullptr;
ALLEGRO_BITMAP* d_im_leaving = nullptr;
ALLEGRO_BITMAP* d_okay_son = nullptr;
ALLEGRO_BITMAP* d_yes_dear = nullptr;
ALLEGRO_BITMAP* d_yes_son = nullptr;

ALLEGRO_BITMAP* d_can_i_have_job = nullptr;
ALLEGRO_BITMAP* d_dot = nullptr;
ALLEGRO_BITMAP* d_hello_frog  = nullptr;
ALLEGRO_BITMAP* d_hello_bird = nullptr;
ALLEGRO_BITMAP* d_i_can_swim = nullptr;
ALLEGRO_BITMAP* d_i_ran_home = nullptr;
ALLEGRO_BITMAP* d_most_cannot_swim = nullptr;
ALLEGRO_BITMAP* d_mr_bird = nullptr;
ALLEGRO_BITMAP* d_new_river_captain = nullptr;
ALLEGRO_BITMAP* d_okay = nullptr;
ALLEGRO_BITMAP* d_what_happened_to_last = nullptr;
ALLEGRO_BITMAP* d_yes_i_know = nullptr;
ALLEGRO_BITMAP* d_yes = nullptr;
ALLEGRO_BITMAP* d_id_like_lift = nullptr;
ALLEGRO_BITMAP* d_thankyou_for_lift = nullptr;


ALLEGRO_BITMAP* d_s_id_like_lift = nullptr;
ALLEGRO_BITMAP* d_s_but_youre_a = nullptr;
ALLEGRO_BITMAP* d_s_so = nullptr;
ALLEGRO_BITMAP* d_s_youll_sting = nullptr;
ALLEGRO_BITMAP* d_s_are_you_a = nullptr;
ALLEGRO_BITMAP* d_s_i_need_to_get_across = nullptr;
ALLEGRO_BITMAP* d_s_do_you_think_stupid = nullptr;
ALLEGRO_BITMAP* d_s_ill_take_you = nullptr;
ALLEGRO_BITMAP* d_s_good = nullptr;

ALLEGRO_BITMAP* d_s_you_stung = nullptr;
ALLEGRO_BITMAP* d_s_now_we_both_die = nullptr;
ALLEGRO_BITMAP* d_s_what_did_you_expect = nullptr;
ALLEGRO_BITMAP* d_s_i_sting = nullptr;
ALLEGRO_BITMAP* d_s_you_should_never_have = nullptr;

ALLEGRO_BITMAP* d_numbers[] = { nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr };

ALLEGRO_BITMAP* side_anim[] = { nullptr, nullptr ,nullptr ,nullptr ,nullptr ,nullptr ,nullptr ,nullptr ,nullptr ,nullptr };
ALLEGRO_BITMAP* top_anim[] = { nullptr, nullptr ,nullptr ,nullptr ,nullptr ,nullptr ,nullptr ,nullptr ,nullptr ,nullptr };

ALLEGRO_BITMAP* b_transit_background = nullptr;
ALLEGRO_BITMAP* b_bush = nullptr;
ALLEGRO_BITMAP* b_stone = nullptr;
ALLEGRO_BITMAP* b_wood = nullptr;
ALLEGRO_BITMAP* b_city = nullptr;


ALLEGRO_BITMAP* b_river_1 = nullptr;
ALLEGRO_BITMAP* b_river_2 = nullptr;
ALLEGRO_BITMAP* b_river_3 = nullptr;
ALLEGRO_BITMAP* b_river_crossing_day_1 = nullptr;
ALLEGRO_BITMAP* b_day_1_complete = nullptr;
ALLEGRO_BITMAP* b_river_crossing_day_2 = nullptr;


ALLEGRO_BITMAP* b_bird_brown_profile = nullptr;
ALLEGRO_BITMAP* b_bird_brown_top = nullptr;
ALLEGRO_BITMAP* b_bird_red_profile = nullptr;
ALLEGRO_BITMAP* b_bird_red_top = nullptr;
ALLEGRO_BITMAP* b_bird_green_profile = nullptr;
ALLEGRO_BITMAP* b_bird_green_top = nullptr;
ALLEGRO_BITMAP* b_cat_brown_profile = nullptr;
ALLEGRO_BITMAP* b_cat_brown_top = nullptr;
ALLEGRO_BITMAP* b_cat_black_profile = nullptr;
ALLEGRO_BITMAP* b_cat_black_top = nullptr;
ALLEGRO_BITMAP* b_cat_yellow_profile = nullptr;
ALLEGRO_BITMAP* b_cat_yellow_top = nullptr;

ALLEGRO_BITMAP* b_scorpion_profile = nullptr;
ALLEGRO_BITMAP* b_scorpion_top = nullptr;

ALLEGRO_BITMAP* b_stung = nullptr;
ALLEGRO_BITMAP* b_stung_1 = nullptr;
ALLEGRO_BITMAP* b_stung_2 = nullptr;
ALLEGRO_BITMAP* b_stung_3 = nullptr;

ALLEGRO_BITMAP* b_scorpion_back = nullptr;

ALLEGRO_BITMAP* b_game_over = nullptr;





ALLEGRO_EVENT_QUEUE* queue = nullptr;
ALLEGRO_TIMER* frameTimer = nullptr;
ALLEGRO_DISPLAY* display = nullptr;



ALLEGRO_COLOR mask = al_map_rgb(255, 0, 255);

void init() {


    al_init();
    al_init_image_addon();
    al_init_primitives_addon();

    al_install_keyboard();

    ALLEGRO_BITMAP* loadingSplash = LoadImageFromArray(loading_splash);
    display = al_create_display(640, 480);
    al_draw_scaled_bitmap(loadingSplash, 0, 0, 60, 46, 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);
    al_flip_display();
    al_destroy_bitmap(loadingSplash);


    /////////////////////////////////////////

    b_menuSplash = LoadImageFromArray(menu_splash);
    b_cutscene_frog = LoadImageFromArray(frog_home);
    b_cutscene_parent_frogs = LoadImageFromArray(frog_parents_home);
    b_river_background = LoadImageFromArray(river_background);
    b_town_background = LoadImageFromArray(town_background);
    b_scorpion_town_background = LoadImageFromArray(scorpion_town_background);

    d_father = LoadImageFromArray(father);
    d_mother = LoadImageFromArray(mother);
    d_goodbye = LoadImageFromArray(goodbye);
    d_im_leaving = LoadImageFromArray(im_leaving);
    d_okay_son = LoadImageFromArray(okay_son);
    d_yes_dear = LoadImageFromArray(yes_dear);
    d_yes_son = LoadImageFromArray(yes_son);

    d_can_i_have_job = LoadImageFromArray(can_i_have_job);
    d_dot = LoadImageFromArray(dot);
    d_hello_frog = LoadImageFromArray(hello_frog);
    d_hello_bird = LoadImageFromArray(hello_bird);
    d_i_can_swim = LoadImageFromArray(i_can_swim);
    d_i_ran_home = LoadImageFromArray(i_ran_home);
    d_most_cannot_swim = LoadImageFromArray(most_cannot_swim);
    d_mr_bird = LoadImageFromArray(mr_bird);
    d_new_river_captain = LoadImageFromArray(new_river_captain);
    d_okay = LoadImageFromArray(okay);
    d_what_happened_to_last = LoadImageFromArray(what_happened_to_last);
    d_yes_i_know = LoadImageFromArray(yes_i_know);
    d_yes = LoadImageFromArray(yes);
    d_id_like_lift = LoadImageFromArray(id_like_a_lift);
    d_thankyou_for_lift = LoadImageFromArray(thankyou_for_lift);

    d_s_id_like_lift = LoadImageFromArray(scorpion_like_lift);
    d_s_but_youre_a = LoadImageFromArray(but_scorpion);
    d_s_so = LoadImageFromArray(scorpion_so);
    d_s_youll_sting = LoadImageFromArray(youll_sting_me);
    d_s_are_you_a = LoadImageFromArray(what_are_you);
    d_s_i_need_to_get_across = LoadImageFromArray(i_need_to_cross);
    d_s_do_you_think_stupid = LoadImageFromArray(do_you_think_im_stupid);
    d_s_ill_take_you = LoadImageFromArray(ill_take_you);
    d_s_good = LoadImageFromArray(good);

    d_s_you_stung = LoadImageFromArray(you_stung);
    d_s_now_we_both_die = LoadImageFromArray(now_we_both_die);
    d_s_what_did_you_expect = LoadImageFromArray(what_did_you_expect);
    d_s_i_sting = LoadImageFromArray(i_sting);
    d_s_you_should_never_have = LoadImageFromArray(you_should_never_have);

    b_game_over = LoadImageFromArray(game_over);



    ALLEGRO_BITMAP* numbers_b = LoadImageFromArray(numbers);
    ALLEGRO_BITMAP* oldmap = al_get_target_bitmap();
    for (int i = 0; i < 10; i++) {
        ALLEGRO_BITMAP* b = al_create_bitmap(8, 11);
        al_set_target_bitmap(b);
        al_draw_bitmap(numbers_b, -i * 8, 0, 0);
        d_numbers[i] = b;
    }
    al_set_target_bitmap(oldmap);

    al_destroy_bitmap(numbers_b);


    side_anim[0] = LoadImageFromArray(frog_side_1);
    side_anim[1] = LoadImageFromArray(frog_side_2);
    side_anim[2] = LoadImageFromArray(frog_side_3);
    side_anim[3] = LoadImageFromArray(frog_side_4);
    side_anim[4] = LoadImageFromArray(frog_side_5);
    side_anim[5] = LoadImageFromArray(frog_side_6);
    side_anim[6] = LoadImageFromArray(frog_side_7);
    side_anim[7] = LoadImageFromArray(frog_side_8);
    side_anim[8] = LoadImageFromArray(frog_side_9);
    side_anim[9] = LoadImageFromArray(frog_side_10);

    top_anim[0] = LoadImageFromArray(frog_top_1);
    top_anim[1] = LoadImageFromArray(frog_top_2);
    top_anim[2] = LoadImageFromArray(frog_top_3);
    top_anim[3] = LoadImageFromArray(frog_top_4);
    top_anim[4] = LoadImageFromArray(frog_top_5);
    top_anim[5] = LoadImageFromArray(frog_top_6);
    top_anim[6] = LoadImageFromArray(frog_top_7);
    top_anim[7] = LoadImageFromArray(frog_top_8);
    top_anim[8] = LoadImageFromArray(frog_top_9);
    top_anim[9] = LoadImageFromArray(frog_top_10);

    for (int i = 0; i < 10; i++)
        al_convert_mask_to_alpha(side_anim[i], mask);
    for (int i = 0; i < 10; i++)
        al_convert_mask_to_alpha(top_anim[i], mask);


    b_transit_background = LoadImageFromArray(transit_background);
    b_bush = LoadImageFromArray(bush);
    al_convert_mask_to_alpha(b_bush, mask);
    b_stone = LoadImageFromArray(stone);
    al_convert_mask_to_alpha(b_stone, mask);
    b_wood = LoadImageFromArray(wood);
    al_convert_mask_to_alpha(b_wood, mask);
    b_city = LoadImageFromArray(city);
    al_convert_mask_to_alpha(b_city, mask);
    ALLEGRO_BITMAP* scaled_city = al_create_bitmap(640, 480);
    ALLEGRO_BITMAP* oldb = al_get_target_bitmap();
    al_set_target_bitmap(scaled_city);
    al_draw_scaled_bitmap(b_city, 0, 0, 192, 144, 0, 0, 640, 480, 0);
    al_set_target_bitmap(oldb);
    al_destroy_bitmap(b_city);
    b_city = scaled_city;



    b_frog_town_job = LoadImageFromArray(frog_town_job);
    b_bird_town_job = LoadImageFromArray(bird_town_job);
    b_bird_town_job_scared = LoadImageFromArray(bird_town_job_scared);

    b_stung = LoadImageFromArray(frog_stung);
    b_stung_1 = LoadImageFromArray(frog_stung_1);
    b_stung_2 = LoadImageFromArray(frog_stung_2);
    b_stung_3 = LoadImageFromArray(frog_stung_3);
    b_scorpion_back = LoadImageFromArray(scorpion_back);



    b_river_crossing_day_1 = LoadImageFromArray(river_crossing_day_1);
    b_day_1_complete = LoadImageFromArray(day_1_complete);
    al_convert_mask_to_alpha(b_day_1_complete, mask);
    al_convert_mask_to_alpha(b_day_1_complete, al_map_rgb(0,255,255));

    al_convert_mask_to_alpha(b_river_crossing_day_1, mask);
    b_river_1 = LoadImageFromArray(river_1);
    b_river_2 = LoadImageFromArray(river_2);
    b_river_3 = LoadImageFromArray(river_3);


    b_river_crossing_day_2 = LoadImageFromArray(river_crossing_day_2);
    al_convert_mask_to_alpha(b_river_crossing_day_2, mask);


    b_bird_brown_profile = LoadImageFromArray(bird_brown_profile);
    al_convert_mask_to_alpha(b_bird_brown_profile, mask);
    b_bird_brown_top = LoadImageFromArray(bird_brown_top);
    al_convert_mask_to_alpha(b_bird_brown_top, mask);
    b_bird_red_profile = LoadImageFromArray(bird_red_profile);
    al_convert_mask_to_alpha(b_bird_red_profile, mask);
    b_bird_red_top = LoadImageFromArray(bird_red_top);
    al_convert_mask_to_alpha(b_bird_red_top, mask);
    b_bird_green_profile = LoadImageFromArray(bird_green_profile);
    al_convert_mask_to_alpha(b_bird_green_profile, mask);
    b_bird_green_top = LoadImageFromArray(bird_green_top);
    al_convert_mask_to_alpha(b_bird_green_top, mask);
    b_cat_brown_profile = LoadImageFromArray(cat_brown_profile);
    al_convert_mask_to_alpha(b_cat_brown_profile, mask);
    b_cat_brown_top = LoadImageFromArray(cat_brown_top);
    al_convert_mask_to_alpha(b_cat_brown_top, mask);
    b_cat_black_profile = LoadImageFromArray(cat_black_profile);
    al_convert_mask_to_alpha(b_cat_black_profile, mask);
    b_cat_black_top = LoadImageFromArray(cat_black_top);
    al_convert_mask_to_alpha(b_cat_black_top, mask);
    b_cat_yellow_profile = LoadImageFromArray(cat_yellow_profile);
    al_convert_mask_to_alpha(b_cat_yellow_profile, mask);
    b_cat_yellow_top = LoadImageFromArray(cat_yellow_top);
    al_convert_mask_to_alpha(b_cat_yellow_top, mask);

    b_scorpion_profile = LoadImageFromArray(scorpion_profile);
    al_convert_mask_to_alpha(b_scorpion_profile, mask);
    b_scorpion_top = LoadImageFromArray(scorpion_top);
    al_convert_mask_to_alpha(b_scorpion_top, mask);
    

    /////////////////////////////////////////

    queue = al_create_event_queue();
    al_register_event_source(queue, al_get_keyboard_event_source());
    al_register_event_source(queue, al_get_display_event_source(display));

    frameTimer = al_create_timer(FRAME_INTERVAL);
    al_start_timer(frameTimer);
    al_register_event_source(queue, al_get_timer_event_source(frameTimer));

    
}

void MenuSplash() {

    int ms_w = al_get_bitmap_width(b_menuSplash);
    int ms_h = al_get_bitmap_height(b_menuSplash);

    while (1) {

        ALLEGRO_EVENT e;
        al_wait_for_event(queue, &e);

        if (e.type == ALLEGRO_EVENT_DISPLAY_CLOSE) {
            gameRunning = false;
            return;
        }

        if (e.type == ALLEGRO_EVENT_KEY_DOWN) {
            gamestate = 1;
            return;
        }

        if (e.type == ALLEGRO_EVENT_TIMER) {
            al_draw_scaled_bitmap(b_menuSplash, 0, 0, ms_w, ms_h, 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);
            al_flip_display();
        }


    }

}


void Start_Cutscene() {

    double frametime = FRAME_INTERVAL * 1000;

    int timings[] = {1500, 2000, 500, 2000, 500, 2000, 500, 2000, 500, 5000, 500, 2000, 500, 3000, 500};
    ALLEGRO_BITMAP* background[] = { b_cutscene_frog,  b_cutscene_frog, b_cutscene_frog, b_cutscene_parent_frogs,b_cutscene_parent_frogs, b_cutscene_frog,b_cutscene_frog, b_cutscene_parent_frogs,b_cutscene_parent_frogs, b_cutscene_frog,b_cutscene_frog, b_cutscene_parent_frogs,b_cutscene_parent_frogs, b_cutscene_frog,b_cutscene_frog };
    ALLEGRO_BITMAP* dialog[] = { nullptr, d_mother, nullptr, d_yes_dear, nullptr, d_father, nullptr, d_yes_son, nullptr, d_im_leaving, nullptr, d_okay_son, nullptr, d_goodbye, nullptr };

    int time = 0;
    int timing_i = 0;

#define DIALOG_MARGIN_SIDE 100
#define DIALOG_MARGIN_BOTTOM 20

    while (1) {

        ALLEGRO_EVENT e;
        al_wait_for_event(queue, &e);
        
        if (e.type == ALLEGRO_EVENT_DISPLAY_CLOSE) {
            gameRunning = false;
            return;
        }
        
        if (e.type == ALLEGRO_EVENT_TIMER) {
            int ms_w = al_get_bitmap_width(background[timing_i]);
            int ms_h = al_get_bitmap_height(background[timing_i]);
            al_draw_scaled_bitmap(background[timing_i], 0, 0, ms_w, ms_h, 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);

            if (dialog[timing_i] != nullptr) {
                int d_w = al_get_bitmap_width(dialog[timing_i]);
                int d_h = al_get_bitmap_height(dialog[timing_i]);
                
                int ds_w = DISPLAY_WIDTH - DIALOG_MARGIN_SIDE *2;
                int ds_h = ds_w / d_w * d_h;

                al_draw_scaled_bitmap(dialog[timing_i], 0, 0, d_w, d_h, DIALOG_MARGIN_SIDE,DISPLAY_HEIGHT - (DIALOG_MARGIN_BOTTOM + ds_h), ds_w, ds_h, 0);
            }
            

            al_flip_display();
        }

        if (time > timings[timing_i]) {
            time = 0;
            timing_i++;
            if (timing_i >= sizeof(timings)/4) {
                gamestate++;
                return;
            }
        }

        time += frametime;
    }

}


void Transit_Scene() {


#define ANIM_TIME 100
#define TRANSIT_TIME 8000

    double frametime = FRAME_INTERVAL * 1000;
    int time = 0;
    int anim_i = 0;
    int transit_time = 0;

    int tb_w = al_get_bitmap_width(b_transit_background);
    int tb_h = al_get_bitmap_height(b_transit_background);

    int bushes[] = { DISPLAY_WIDTH / 10, DISPLAY_WIDTH / 8, DISPLAY_WIDTH / 4, DISPLAY_WIDTH / 6.4, DISPLAY_WIDTH, DISPLAY_WIDTH * 1.1, DISPLAY_WIDTH * 2, DISPLAY_WIDTH * 0.3 };
    int bush_speed = DISPLAY_WIDTH/100;
    int bush_w = al_get_bitmap_width(b_bush);
    int woods[] = { DISPLAY_WIDTH / 10, DISPLAY_WIDTH / 8, DISPLAY_WIDTH / 4, DISPLAY_WIDTH / 6.4, DISPLAY_WIDTH, DISPLAY_WIDTH * 1.1, DISPLAY_WIDTH * 2, DISPLAY_WIDTH * 0.3 };
    int wood_speed = DISPLAY_WIDTH/100;
    int wood_w = al_get_bitmap_width(b_wood);

    int stones[] = {DISPLAY_WIDTH*0.1, DISPLAY_WIDTH * 0.2, DISPLAY_WIDTH * 0.3, DISPLAY_WIDTH * 0.4, DISPLAY_WIDTH * 0.5, DISPLAY_WIDTH * 0.6, DISPLAY_WIDTH * 0.7, DISPLAY_WIDTH * 0.8, DISPLAY_WIDTH * 0.9, DISPLAY_WIDTH * 1, DISPLAY_WIDTH * 1.1, DISPLAY_WIDTH * 1.2, DISPLAY_WIDTH * 1.3, DISPLAY_WIDTH * 1.4, DISPLAY_WIDTH * 1.5, DISPLAY_WIDTH * 1.6, DISPLAY_WIDTH * 1.7,DISPLAY_WIDTH * 1.8,DISPLAY_WIDTH * 1.9, DISPLAY_WIDTH * 2};
    int stone_speed = DISPLAY_WIDTH/100;
    int stone_w = al_get_bitmap_width(b_stone);

    int backbushes[] = {DISPLAY_WIDTH*0.1, DISPLAY_WIDTH * 0.2, DISPLAY_WIDTH * 0.3, DISPLAY_WIDTH * 0.4, DISPLAY_WIDTH * 0.5, DISPLAY_WIDTH * 0.6, DISPLAY_WIDTH * 0.7, DISPLAY_WIDTH * 0.8, DISPLAY_WIDTH * 0.9, DISPLAY_WIDTH * 1, DISPLAY_WIDTH * 1.1, DISPLAY_WIDTH * 1.2, DISPLAY_WIDTH * 1.3, DISPLAY_WIDTH * 1.4, DISPLAY_WIDTH * 1.5, DISPLAY_WIDTH * 1.6, DISPLAY_WIDTH * 1.7,DISPLAY_WIDTH * 1.8,DISPLAY_WIDTH * 1.9, DISPLAY_WIDTH * 2};

    int city_p = DISPLAY_WIDTH + al_get_bitmap_width(b_city);
    int city_draw_frame = TRANSIT_TIME/frametime - al_get_bitmap_width(b_city)*2 / stone_speed;


    int frame = 0;

    while (1) {

        ALLEGRO_EVENT e;
        al_wait_for_event(queue, &e);

        if (e.type == ALLEGRO_EVENT_DISPLAY_CLOSE) {
            gameRunning = false;
            return;
        }
        

        if (e.type == ALLEGRO_EVENT_TIMER) {
            frame++;
            transit_time += frametime;

            if (transit_time > TRANSIT_TIME) {
                gamestate++;
                return;
            }

            time += frametime;
            if (time > ANIM_TIME) {
                time %= ANIM_TIME;
                anim_i++;
                if (anim_i >= 10)
                    anim_i = 0;
            }

            al_draw_scaled_bitmap(b_transit_background, 0, 0, tb_w, tb_h, 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);


            for (int i = 0; i < 20; i++) {

                backbushes[i] -= bush_speed;
                if (backbushes[i] < 0 - bush_w) {
                    backbushes[i] += DISPLAY_WIDTH + bush_w;
                }

                al_draw_bitmap(b_bush, backbushes[i], DISPLAY_HEIGHT / 1.5, 0);

            }

            for (int i = 0; i < 8; i++) {

                woods[i] -= wood_speed;
                if (woods[i] < 0 - wood_w) {
                    woods[i] += DISPLAY_WIDTH + wood_w;
                }

                al_draw_bitmap(b_wood, woods[i], DISPLAY_HEIGHT / 2, 0);

            }

            for (int i = 0; i < 8; i++) {

                bushes[i] -= bush_speed;
                if (bushes[i] < 0-bush_w) {
                    bushes[i] += DISPLAY_WIDTH + bush_w;
                }

                al_draw_bitmap(b_bush, bushes[i], DISPLAY_HEIGHT / 3, 0);

            }

            for (int i = 0; i < 20; i++) {

                stones[i] -= stone_speed;
                if (stones[i] < 0-stone_w) {
                    stones[i] += DISPLAY_WIDTH + stone_w;
                }

                al_draw_bitmap(b_stone, stones[i], DISPLAY_HEIGHT / 1.5, 0);

            }

            if (frame >= city_draw_frame) {
                city_p -= stone_speed;
                al_draw_bitmap(b_city, city_p, DISPLAY_HEIGHT * 0.3, 0);
            }
            


            al_draw_bitmap(side_anim[anim_i], DISPLAY_WIDTH/2 - 64, DISPLAY_HEIGHT*0.66, 0);
            al_flip_display();
        }

    }

}



void Job_Scene() {

    double frametime = FRAME_INTERVAL * 1000;

    int timings[] = { 1000, 2000, 500, 2000, 500, 2000, 500, 3000, 500, 2000, 500, 1000, 500, 2000, 500, 3000, 500 ,3000, 500, 2000, 500, 2000, 500, 3000, 500, 3000, 1000 };
    ALLEGRO_BITMAP* background[] = { b_frog_town_job,  b_frog_town_job, b_bird_town_job, b_bird_town_job,b_frog_town_job, b_frog_town_job,b_bird_town_job, b_bird_town_job,b_frog_town_job, b_frog_town_job,b_bird_town_job, b_bird_town_job,b_bird_town_job, b_bird_town_job,b_bird_town_job, b_bird_town_job, b_bird_town_job, b_bird_town_job, b_frog_town_job, b_frog_town_job, b_bird_town_job, b_bird_town_job, b_frog_town_job, b_frog_town_job, b_frog_town_job, b_frog_town_job, b_bird_town_job_scared };
    ALLEGRO_BITMAP* dialog[] = { nullptr, d_hello_bird, nullptr, d_hello_frog, nullptr, d_i_ran_home, nullptr, d_okay, nullptr, d_can_i_have_job, nullptr, d_yes, nullptr, d_dot, nullptr, d_new_river_captain, nullptr, d_most_cannot_swim, nullptr, d_i_can_swim, nullptr, d_yes_i_know, nullptr, d_what_happened_to_last, nullptr, d_mr_bird, nullptr };

    int time = 0;
    int timing_i = 0;

#define DIALOG_MARGIN_SIDE 100
#define DIALOG_MARGIN_BOTTOM 20

    while (1) {

        ALLEGRO_EVENT e;
        al_wait_for_event(queue, &e);

        if (e.type == ALLEGRO_EVENT_DISPLAY_CLOSE) {
            gameRunning = false;
            return;
        }

        if (e.type == ALLEGRO_EVENT_TIMER) {
            int ms_w = al_get_bitmap_width(background[timing_i]);
            int ms_h = al_get_bitmap_height(background[timing_i]);
            al_draw_scaled_bitmap(background[timing_i], 0, 0, ms_w, ms_h, 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);

            if (dialog[timing_i] != nullptr) {
                int d_w = al_get_bitmap_width(dialog[timing_i]);
                int d_h = al_get_bitmap_height(dialog[timing_i]);

                int ds_w = DISPLAY_WIDTH - DIALOG_MARGIN_SIDE * 2;
                int ds_h = ds_w / d_w * d_h;

                al_draw_scaled_bitmap(dialog[timing_i], 0, 0, d_w, d_h, DIALOG_MARGIN_SIDE, DISPLAY_HEIGHT - (DIALOG_MARGIN_BOTTOM + ds_h), ds_w, ds_h, 0);
            }


            al_flip_display();
        }

        if (time > timings[timing_i]) {
            time = 0;
            timing_i++;
            if (timing_i >= sizeof(timings) / 4) {
                gamestate++;
                return;
            }
        }

        time += frametime;
    }
}





void Game() {

    double frametime = FRAME_INTERVAL * 1000;

    int day_1_rides[] = { 30,50,20,40,33,20,12,67,55 };
    const char* day_1_rider_names[] = { "Mr red","Mr Green","Jerry","Alfred","Mr Yellow","Cat","Supreme Leader of North Korea", "Willy", "Wonka"};
    ALLEGRO_BITMAP* day_1_riders[] = { b_cat_black_top,b_bird_brown_top,b_bird_green_top,b_cat_brown_top,b_bird_red_top,b_cat_brown_top,b_bird_green_top,b_cat_yellow_top,b_cat_black_top };
    ALLEGRO_BITMAP* day_1_rider_splashes[] = { b_cat_black_profile,b_bird_brown_profile,b_bird_green_profile,b_cat_brown_profile,b_bird_red_profile,b_cat_brown_profile,b_bird_green_profile,b_cat_yellow_profile,b_cat_black_profile };
#define MAX_RIDERS 9

    int day = 1;
    int rider_i = 0;
    bool rideStarted = false;
    int splashTime = 2000;
    int splashTimer = 0;
    int localstate = 0;

    int day_time = 0;
    int max_day_time = 40 * 1000;

    int anim_time = 0;
    int anim_i = 0;

    int river_1_w = al_get_bitmap_width(b_river_1);
    int river_1_h = al_get_bitmap_width(b_river_1);
    int river_2_w = al_get_bitmap_width(b_river_2);
    int river_2_h = al_get_bitmap_width(b_river_2);
    int river_3_w = al_get_bitmap_width(b_river_3);
    int river_3_h = al_get_bitmap_width(b_river_3);

    int irid_hat_frame = 0;
    

    int river_game_w = DISPLAY_WIDTH * 4;
    int river_game_h = river_game_w / (river_1_w + river_2_w + river_3_w) * river_1_h;


    int frog_x = DISPLAY_WIDTH * 0.3;
    int frog_y = DISPLAY_HEIGHT / 2;

#define RIVER_SCALE 5
#define RIVER_OFFSET_Y -80
    int river_offset_x = 0;
    int river_speed = 5;
    int river_offset_end = river_game_w;

    int d_w = al_get_bitmap_width(d_id_like_lift);
    int d_h = al_get_bitmap_height(d_id_like_lift);

    while (1) {


        ALLEGRO_EVENT e;
        al_wait_for_event(queue, &e);

        if (e.type == ALLEGRO_EVENT_DISPLAY_CLOSE) {
            gameRunning = false;
            return;
        }
        
   

        if (e.type == ALLEGRO_EVENT_TIMER) {
            
            al_draw_scaled_bitmap(b_river_1, 0, 0, river_1_w, river_1_h,     0 - river_offset_x, RIVER_OFFSET_Y,  river_1_w* RIVER_SCALE,   river_1_h* RIVER_SCALE, 0);
            al_draw_scaled_bitmap(b_river_2, 0, 0, river_2_w, river_2_h,     -1 + -river_offset_x + river_1_w * RIVER_SCALE, RIVER_OFFSET_Y,  river_2_w * RIVER_SCALE,  river_2_h * RIVER_SCALE, 0);
            al_draw_scaled_bitmap(b_river_3, 0, 0, river_3_w, river_3_h,     -2 + -river_offset_x + river_1_w * RIVER_SCALE + river_2_w * RIVER_SCALE, RIVER_OFFSET_Y,  river_3_w * RIVER_SCALE,  river_3_h * RIVER_SCALE, 0);

            if (localstate == 0) {
                al_draw_scaled_bitmap(b_river_crossing_day_1, 0, 0, al_get_bitmap_width(b_river_crossing_day_1), al_get_bitmap_height(b_river_crossing_day_1), 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);
                
                splashTimer += frametime;
                if (splashTimer > splashTime) {
                    localstate++;
                    splashTimer = 0;
                }
                    
            }

            if (localstate == 1) {
                al_draw_scaled_bitmap(b_town_background, 0, 0, al_get_bitmap_width(b_river_background), al_get_bitmap_height(b_river_background), 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);
                al_draw_scaled_bitmap(day_1_rider_splashes[rider_i], 0, 0, al_get_bitmap_width(day_1_rider_splashes[rider_i]), al_get_bitmap_height(day_1_rider_splashes[rider_i]), 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);
                
                int ds_w = DISPLAY_WIDTH - DIALOG_MARGIN_SIDE * 2;
                int ds_h = ds_w / d_w * d_h;

                al_draw_scaled_bitmap(d_id_like_lift, 0, 0, d_w, d_h, DIALOG_MARGIN_SIDE, DISPLAY_HEIGHT - (DIALOG_MARGIN_BOTTOM + ds_h), ds_w, ds_h, 0);

                const int num_w = 40;
                const int num_h = 55;

                int num1 = floor(day_1_rides[rider_i]/10);
                int num2 = day_1_rides[rider_i] % 10;


                al_draw_scaled_bitmap(d_numbers[num1], 0, 0, 8, 11, DISPLAY_WIDTH - (DIALOG_MARGIN_SIDE + num_w), DISPLAY_HEIGHT - (DIALOG_MARGIN_BOTTOM + num_h), num_w, num_h, 0);
                al_draw_scaled_bitmap(d_numbers[num2], 0, 0, 8, 11, DISPLAY_WIDTH - (DIALOG_MARGIN_SIDE + num_w) + num_w, DISPLAY_HEIGHT - (DIALOG_MARGIN_BOTTOM + num_h), num_w, num_h, 0);
                
                splashTimer += frametime;
                if (splashTimer > splashTime) {
                    localstate++;
                    splashTimer = 0;
                }
               
            }

            if (localstate == 2) {

                anim_time += frametime;
                day_time += frametime;
                if (anim_time > ANIM_TIME) {
                    anim_time %= ANIM_TIME;
                    anim_i++;
                    if (anim_i >= 10)
                        anim_i = 0;
                }

                if (day_time >= max_day_time) {
                    localstate = 4;
                }

                river_offset_x += river_speed;
                if (river_offset_x >= river_offset_end)
                {
                    localstate = 3;
                    splashTimer = 0;
                }


                al_draw_rotated_bitmap(top_anim[anim_i], 192 / 2, 144 / 2, DISPLAY_WIDTH / 2 - 64, DISPLAY_HEIGHT * 0.66, PI/2, 0);
                al_draw_rotated_bitmap(day_1_riders[rider_i], 192 / 2, 144 / 2, DISPLAY_WIDTH / 2 - 64, DISPLAY_HEIGHT * 0.66, PI/2, 0);


            }

            if (localstate == 3) {

                splashTimer += frametime;
                
                if (splashTimer > splashTime) {
                    localstate = 1;
                    river_offset_x = 0;
                    rider_i++;
                    if (rider_i >= 9)
                        rider_i = 0;
                    splashTimer = 0;

                }

                

                int d_ty_w = al_get_bitmap_width(d_thankyou_for_lift);
                int d_ty_h = al_get_bitmap_height(d_thankyou_for_lift);

                int ds_w = DISPLAY_WIDTH - DIALOG_MARGIN_SIDE * 2;
                int ds_h = ds_w / d_ty_w * d_ty_h;

                al_draw_scaled_bitmap(b_river_background, 0, 0, al_get_bitmap_width(b_river_background), al_get_bitmap_height(b_river_background), 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);
                al_draw_scaled_bitmap(day_1_rider_splashes[rider_i], 0, 0, al_get_bitmap_width(day_1_rider_splashes[rider_i]), al_get_bitmap_height(day_1_rider_splashes[rider_i]), 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);
                al_draw_scaled_bitmap(d_thankyou_for_lift, 0, 0, d_ty_w, d_ty_h, DIALOG_MARGIN_SIDE, DISPLAY_HEIGHT - (DIALOG_MARGIN_BOTTOM + ds_h), ds_w, ds_h, 0);


            }

            if (localstate == 4) {

                splashTimer += frametime;

                if (splashTimer > 4000) {
                    localstate = 5;
                    river_offset_x = 0;
                    rider_i = 4;
                    splashTimer = 0;

                }

                irid_hat_frame += frametime;

                ALLEGRO_COLOR irid_hat_color = al_map_rgb(abs(sin((double)irid_hat_frame/100)) * 150, abs(sin((double)irid_hat_frame / 75)) * 150, abs(sin((double)irid_hat_frame / 50)) * 150);

                al_draw_filled_rectangle(DISPLAY_WIDTH / 2 , DISPLAY_HEIGHT / 2 - 150, DISPLAY_WIDTH / 2 + 70, DISPLAY_HEIGHT / 2 -50, irid_hat_color);
               // al_draw_filled_rectangle(DISPLAY_WIDTH / 2 , DISPLAY_HEIGHT / 2 - 60, DISPLAY_WIDTH / 2 + 70, DISPLAY_HEIGHT / 2 -50, al_map_rgb(255,0,255));
                al_draw_scaled_bitmap(b_day_1_complete, 0, 0, al_get_bitmap_width(b_day_1_complete), al_get_bitmap_height(b_day_1_complete), 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);

            }

            if (localstate == 5) {

                al_clear_to_color(al_map_rgb(200, 200, 200));
                al_draw_scaled_bitmap(b_river_crossing_day_2, 0, 0, al_get_bitmap_width(b_river_crossing_day_2), al_get_bitmap_height(b_river_crossing_day_2), 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);

                splashTimer += frametime;
                if (splashTimer > 5000) {
                    localstate++;
                    splashTimer = 0;
                    anim_i = 0;
                    anim_time = 0;
                }

            }

            if (localstate == 6) {


                int timings[] = { 1000, 500, 2000, 500, 2000, 500, 2000, 500, 3000, 500, 3000, 500, 5000, 500, 5000, 500, 1000, 500 ,3000, 500};
                ALLEGRO_BITMAP* background[] = { b_frog_town_job,  b_scorpion_profile, b_scorpion_profile, b_frog_town_job,b_frog_town_job, b_scorpion_profile,b_scorpion_profile, b_frog_town_job,b_frog_town_job, b_scorpion_profile,b_scorpion_profile, b_scorpion_profile,b_scorpion_profile, b_scorpion_profile,b_scorpion_profile, b_frog_town_job, b_frog_town_job, b_scorpion_profile, b_scorpion_profile, b_scorpion_profile };
                ALLEGRO_BITMAP* dialog[] = { nullptr, nullptr, d_s_id_like_lift, nullptr, d_s_but_youre_a, nullptr, d_s_so, nullptr, d_s_youll_sting, nullptr, d_s_are_you_a, nullptr, d_s_i_need_to_get_across, nullptr, d_s_do_you_think_stupid, nullptr, d_s_ill_take_you, nullptr, d_s_good, nullptr };

                
                

                al_draw_scaled_bitmap(b_scorpion_town_background, 0, 0, al_get_bitmap_width(b_river_background), al_get_bitmap_height(b_river_background), 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);
                al_draw_scaled_bitmap(background[anim_i], 0, 0, al_get_bitmap_width(background[anim_i]), al_get_bitmap_height(background[anim_i]), 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);
                
                if (dialog[anim_i] != nullptr) {

                    int d_ty_w = al_get_bitmap_width(dialog[anim_i]);
                    int d_ty_h = al_get_bitmap_height(dialog[anim_i]);
                    int ds_w = DISPLAY_WIDTH - DIALOG_MARGIN_SIDE * 2;
                    int ds_h = ds_w / d_ty_w * d_ty_h;

                    al_draw_scaled_bitmap(dialog[anim_i], 0, 0, d_ty_w, d_ty_h, DIALOG_MARGIN_SIDE, DISPLAY_HEIGHT - (DIALOG_MARGIN_BOTTOM + ds_h), ds_w, ds_h, 0);
                }
                    

                anim_time += frametime;

                if (anim_time >= timings[anim_i]) {
                    anim_i++;
                    anim_time = 0;
                    if (anim_i >= 20) {
                        localstate++;
                        river_offset_x = 0;
                        splashTimer = 0;
                        anim_time = 0;
                        day_time = 0;
                    }
                }


            }


            if (localstate == 7) {


                anim_time += frametime;
                day_time += frametime;
                if (anim_time > ANIM_TIME) {
                    anim_time %= ANIM_TIME;
                    anim_i++;
                    if (anim_i >= 10)
                        anim_i = 0;
                }

         

                river_offset_x += river_speed;
                if (river_offset_x >= river_offset_end/2)
                {
                    localstate++;
                    splashTimer = 0;
                   
                }


                al_draw_rotated_bitmap(top_anim[anim_i], 192 / 2, 144 / 2, DISPLAY_WIDTH / 2 - 64, DISPLAY_HEIGHT * 0.66, PI / 2, 0);
                al_draw_rotated_bitmap(b_scorpion_top, 192 / 2, 144 / 2, DISPLAY_WIDTH / 2 - 64, DISPLAY_HEIGHT * 0.66, PI / 2, 0);

            }

            if (localstate == 8) {

                splashTimer += frametime;
                if (splashTimer >= 1000) {
                    localstate++;
                    splashTimer = 0;
                }

                al_draw_rotated_bitmap(top_anim[anim_i], 192 / 2, 144 / 2, DISPLAY_WIDTH / 2 - 64, DISPLAY_HEIGHT * 0.66, PI / 2, 0);
                al_draw_rotated_bitmap(b_scorpion_top, 192 / 2, 144 / 2, DISPLAY_WIDTH / 2 - 64, DISPLAY_HEIGHT * 0.66, PI / 2, 0);

            }

            if (localstate == 9) {

                splashTimer += frametime;
                if (splashTimer >= 3000) {
                    localstate++;
                    splashTimer = 0;
                }

                al_draw_scaled_bitmap(b_stung, 0, 0, al_get_bitmap_width(b_stung), al_get_bitmap_height(b_stung), 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);
            }
            if (localstate == 10) {

                splashTimer += frametime;
                if (splashTimer >= 1500) {
                    localstate++;
                    splashTimer = 0;
                }

                al_draw_scaled_bitmap(b_stung_1, 0, 0, al_get_bitmap_width(b_stung_1), al_get_bitmap_height(b_stung_1), 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);
            }
            if (localstate == 11) {

                splashTimer += frametime;
                if (splashTimer >= 1500) {
                    localstate++;
                    splashTimer = 0;
                }

                al_draw_scaled_bitmap(b_stung_2, 0, 0, al_get_bitmap_width(b_stung_2), al_get_bitmap_height(b_stung_2), 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);
            }
            if (localstate == 12) {

                splashTimer += frametime;
                if (splashTimer >= 3000) {
                    localstate++;
                    splashTimer = 0;
                    anim_i = 0;
                }

                al_draw_scaled_bitmap(b_stung_3, 0, 0, al_get_bitmap_width(b_stung_3), al_get_bitmap_height(b_stung_3), 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);
            }

            if (localstate == 13) {


                int timings[] = { 1000, 3000, 500, 3000, 500, 2000, 500, 3000, 500, 3000, 500, 3000};
                ALLEGRO_BITMAP* background[] = { b_stung,  b_stung, b_stung, b_stung,b_scorpion_back, b_scorpion_back,b_scorpion_back, b_scorpion_back,b_scorpion_back, b_scorpion_back,b_scorpion_back, b_stung};
                ALLEGRO_BITMAP* dialog[] = { nullptr, d_s_you_stung, nullptr, d_s_now_we_both_die, nullptr, d_s_what_did_you_expect, nullptr, d_s_i_sting, nullptr, d_s_you_should_never_have, nullptr, nullptr};




                al_draw_scaled_bitmap(b_scorpion_town_background, 0, 0, al_get_bitmap_width(b_river_background), al_get_bitmap_height(b_river_background), 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);
                al_draw_scaled_bitmap(background[anim_i], 0, 0, al_get_bitmap_width(background[anim_i]), al_get_bitmap_height(background[anim_i]), 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);

                if (dialog[anim_i] != nullptr) {

                    int d_ty_w = al_get_bitmap_width(dialog[anim_i]);
                    int d_ty_h = al_get_bitmap_height(dialog[anim_i]);
                    int ds_w = DISPLAY_WIDTH - DIALOG_MARGIN_SIDE * 2;
                    int ds_h = ds_w / d_ty_w * d_ty_h;

                    al_draw_scaled_bitmap(dialog[anim_i], 0, 0, d_ty_w, d_ty_h, DIALOG_MARGIN_SIDE, DISPLAY_HEIGHT - (DIALOG_MARGIN_BOTTOM + ds_h), ds_w, ds_h, 0);
                }


                anim_time += frametime;

                if (anim_time >= timings[anim_i]) {
                    anim_i++;
                    anim_time = 0;
                    if (anim_i >= 12) {
                        localstate++;
                        splashTimer = 0;
                        anim_time = 0;
                        day_time = 0;
                    }
                }


            }

            if (localstate == 14) {

                al_draw_scaled_bitmap(b_game_over, 0, 0, al_get_bitmap_width(b_game_over), al_get_bitmap_height(b_game_over), 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 0);
                
                splashTimer += frametime;
                if (splashTimer >= 5000) {
                    localstate = 0;
                    gamestate = 0;
                    splashTimer = 0;
                    return;
                }
            }

            al_flip_display();

        }

    }




}



int main()
{
    init();

  // ConvertImageToArray("CONTENT PATH HERE");
  // return 0;
    

    al_clear_to_color(al_map_rgb(0, 0, 0));

    while (gameRunning) {

        

       // al_draw_scaled_bitmap(bitmap, 0, 0, 192, 144, 0, 0, 640, 480, 0);
        switch (gamestate)
        {
        case 0:
            MenuSplash();
            break;
        case 1:
            Start_Cutscene();
            break;
        case 2:
            Transit_Scene();
            break;
        case 3:
            Job_Scene();
            break;
        case 4:
            Game();
            break;
        default:
            gamestate = 0;
            break;
        }
        

    }
}
